require 'zlib'

module ClassNode

  def seek(key)
    unless @sorted_nodes
      sorted_nodes, node_x_class_nodes = [], {}
      self.select('node, class_name, table_name').order('node').each do |class_node|
        sorted_nodes << class_node.node
        node_x_class_nodes[class_node.node] = class_node
      end
      @sorted_nodes, @node_x_class_nodes = sorted_nodes, node_x_class_nodes
    end



    node = @sorted_nodes.bsearch{|node| node >= Zlib::crc32(key.to_s)} || @sorted_nodes.first
    @node_x_class_nodes[node]
  end

end
