require File.expand_path('../album_node', __FILE__)
require File.expand_path('../album_origin', __FILE__)

class Album < AlbumOrigin

  def self.shard(key)
    Object.const_get(AlbumNode.seek(key).class_name)
  end

  def self.gtn(key)
    AlbumNode.seek(key).table_name
  end

  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = Album.gtn(r.uid)

    unless r.id
      r.id = Album.next_id
    end
  end

  before_destroy do |r|
    r.class.table_name = Album.gtn(r.uid)
  end

end
