class AppRecommend < ActiveRecord::Base
  self.table_name = "tb_app_recommend" #推荐app

  attr_accessible :app_name, :channel, :cover_path, :end_time, :intro, :column_type,
                  :is_deleted, :link_url, :name, :position, :start_time, :terminal, :url_type
                  
  has_many :advertisements, dependent: :destroy
  validates_uniqueness_of :name, message: "广告名称已经存在！"

  def terminal_disp
    case self.terminal
    when 1
      "ios"
    when 2
      "android"
    else
      ""
    end
  end

  def channel_disp
    case self.channel
      when 1
        "应用推荐"
      when 2
        "Feed广告"
      else
        ""
    end
  end

  def is_deleted_disp
    case self.is_deleted
      when true
        "是"
      when false
        "否"
      else
        ""
    end
  end

  def column_type_disp
    case self.column_type
      when 1
        "今日推荐"
      when 2
        "热门推荐"
      when 3
        "装机必备"
      else
        ""
    end
  end
end
