class Category < ActiveRecord::Base
  self.table_name = 'tb_category' # 分类

  attr_accessible :name, :title, :cover_path, :parent_id, :order_num, :is_deleted, :is_checked, :is_display, :intro, :icon_version_id

  # name --- 分类名
  # title --- 显示标题
  # cover_path --- 分类图片
  # parent_id --- 父分类
  # order_num --- 排序数字
  # is_deleted --- 是否已删除
  # is_checked --- 是否默认选中（后台用）
  # is_display --- 是否显示
  # intro --- 介绍
  # icon_version_id --- 未使用
  
  has_many :recommend_category_tags
  has_many :tracks
  has_many :albums
end
