require File.expand_path('../chat_node', __FILE__)
require File.expand_path('../chat_origin', __FILE__)

class Chat < ChatOrigin

  def self.shard(key)
    Object.const_get(ChatNode.seek(key).class_name)
  end

  def self.gtn(key)
    ChatNode.seek(key).table_name
  end

  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = Chat.gtn(r.uid)

    unless r.id
      r.id = Chat.next_id
    end
  end

  before_destroy do |r|
    r.class.table_name = Chat.gtn(r.uid)
  end
  
end
