require File.expand_path('../../extenders/chat_extender', __FILE__)

class ChatOrigin < ActiveRecord::Base
  extend ChatExtender

  # 聊天 分表 根据 uid
  self.table_name = 'tb_chat' 

  attr_accessible :is_in, :upload_source,
                  :uid, :nickname, :avatar_path,  
                  :with_uid, :with_nickname, :with_avatar_path,
                  :content, 
                  :has_read,
                  :anno_id

  # is_in --- true:收 /false:发
  # upload_source --- 上传源 1:iphone /2:电脑 /3:android
  # uid nickname avatar_path --- 用户id 昵称 头像
  # with_uid with_nickname with_avatar_path --- 与用户id 昵称 头像 
  # content --- 内容
  # has_read --- 是否已读
  # anno_id --- 公告id(收取公告的场合)

  validates :uid, presence: true

  before_save do |r|
    unless r.id
      r.id = Chat.next_id
    end
  end

end
