require File.expand_path('../comment_node', __FILE__)
require File.expand_path('../comment_origin', __FILE__)

class Comment < CommentOrigin

  def self.shard(key)
    Object.const_get(CommentNode.seek(key).class_name)
  end

  def self.gtn(key)
    CommentNode.seek(key).table_name
  end

  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = Comment.gtn(r.track_id)

    unless r.id
      r.id = Comment.next_id
    end
    if r.second and r.second >= 0
      tb = TrackBlock.shard(r.track_id).where(track_id: r.track_id).first
      if tb
         # 加分块计数
        tb.increase_by_second(r.second)
        # 加彩虹块头像
        bidx = tb.get_block_idx_by_second(r.second)
        if bidx
          avatars = BlockAvatar.shard(r.track_id).where(track_id: r.track_id, block_id: bidx)
          if avatars.count > 0 and avatars.count >= 30 / tb.blocks
            avatars.first.destroy
          end
          BlockAvatar.shard(r.track_id).create(track_id: r.track_id, comment_id: r.id, block_id: bidx, 
            uid: r.uid, avatar_path: r.avatar_path)

          r.block = bidx
        end
      end
    end
  end

  before_destroy do |r|
    r.class.table_name = Comment.gtn(r.track_id)
  end

  after_destroy do |r| 
    if r.second and r.second >= 0
      tb = TrackBlock.shard(r.track_id).where(track_id: r.track_id).first
      if tb
        # 减分块计数
        tb.increase_by_second(r.second, -1)
        # 删掉对应彩虹块头像，再补一张
        if r.block
          avatar = BlockAvatar.shard(r.track_id).where(track_id: r.track_id, block_id: r.block, comment_id: r.id).first
          if avatar
            avatar.destroy

            ba0 = BlockAvatar.shard(r.track_id).where(track_id: r.track_id, block_id: r.block).first
            if ba0
              alter = Comment.shard(r.track_id).where('track_id = ? and block = ? and id < ?', r.track_id, r.block, ba0.comment_id).last
            else
              alter = Comment.shard(r.track_id).where('track_id = ? and block = ?', r.track_id, r.block).last
            end
            if alter
              alter_bidx = tb.get_block_idx_by_second(alter.second)
              BlockAvatar.shard(r.track_id).create(track_id: alter.track_id, comment_id: alter.id, block_id: alter_bidx, 
                uid: alter.uid, avatar_path: alter.avatar_path)
            end
          end
        end
      end
    end

  end

end
