require File.expand_path('../favorite_node', __FILE__)
require File.expand_path('../favorite_origin', __FILE__)

class Favorite < FavoriteOrigin
  
  def self.shard(key)
    Object.const_get(FavoriteNode.seek(key).class_name)
  end

  def self.gtn(key)
    FavoriteNode.seek(key).table_name
  end
  
  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = Favorite.gtn(r.uid)

    unless r.id
      r.id = Favorite.next_id
    end

    tir = TrackInRecord.fetch(r.track_id)
    if tir
      r.is_public = tir.is_public
      r.track_uid = tir.uid
      r.track_nickname = tir.nickname
      r.track_avatar_path = tir.avatar_path
      r.track_duration = tir.duration
      r.title = tir.title
      r.intro = tir.intro
      r.duration = tir.duration
      r.cover_path = tir.cover_path
      r.tags = tir.tags
      r.intro = tir.intro
      r.play_path = tir.play_path
      r.play_path_32 = tir.play_path_32
      r.play_path_64 = tir.play_path_64
      r.play_path_128 = tir.play_path_128
      r.track_created_at = tir.created_at
      r.allow_download = tir.allow_download
      r.allow_comment = tir.allow_comment
      r.download_path = tir.download_path
      r.album_id = tir.album_id
      r.album_title = tir.album_title
      r.album_cover_path = tir.album_cover_path
      r.category_id = tir.category_id
      r.user_source = tir.user_source
    end
  end

  before_destroy do |r|
    r.class.table_name = Favorite.gtn(r.uid)
  end
 
end
