require File.expand_path('../favorite_album_node', __FILE__)
require File.expand_path('../favorite_album_origin', __FILE__)

class FavoriteAlbum < FavoriteAlbumOrigin
	
  def self.shard(key)
    Object.const_get(FavoriteAlbumNode.seek(key).class_name)
  end

  def self.gtn(key)
    FavoriteAlbumNode.seek(key).table_name
  end
  
  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = FavoriteAlbum.gtn(r.uid)

    unless r.id
      r.id = FavoriteAlbum.next_id
    end

    album = TrackSet.fetch(r.album_id)
    if album
      r.album_uid = album.uid
      r.album_nickname = album.nickname 
      r.album_avatar_path = album.avatar_path
      r.title = album.title
      r.tags = album.tags
      r.intro = album.intro
      r.cover_path = album.cover_path
      r.music_category = album.music_category
      r.album_created_at = album.created_at
      r.category_id = album.category_id
      r.op_type = album.op_type
      r.user_source = album.user_source
      r.is_crawler = album.is_crawler
    end

    true
	end

	before_destroy do |r|
		r.class.table_name = FavoriteAlbum.gtn(r.uid)
	end

end