class Feed < ActiveRecord::Base
  self.table_name = 'tb_feed'

  attr_accessible :album_id, :album_title, :track_id, :content, :play_url, :type, :uid
#老版本START
  #现在未使用 获取feed的数据
	def self.get_feed(uid,current_page,page_size)
    begin
      Yajl::Parser.parse FEED_WEB.getWebFeed(uid,current_page,page_size)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end

  #获取feed event的数据
	def self.get_feed_by_score(uid,timeLine,page_size,type=0)
    begin
      Yajl::Parser.parse FEED_WEB.getWebEventJson(uid,timeLine,page_size,type)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end
#获取feed 声音流的数据
  def self.get_feed_content_by_score(uid,timeLine,page_size,type=0)
    begin
      Yajl::Parser.parse FEED_WEB.getContentFeedJson(uid,timeLine,page_size,type)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end

  #删除feed
  def self.del_feed(uid,id,groupIDs,type='event')
    begin
      FEED_WEB.delFeeds(uid,id,type,groupIDs)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end

  #获得用户未读数量
  def self.no_read_num uid
    begin
      FEED_WEB.getAllNoReadNum(uid)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end
#老版本END

#获取feed event的数据
  def self.get_event_by_timeline(key,timeLine,page_size,type)
    begin
      Yajl::Parser.parse FEED_WEB.getWebEventJsonTimeline(key,timeLine,page_size,type)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end

  #获取feed event的数据
  def self.get_event_by_range(key,offset,limit)
    begin
      Yajl::Parser.parse FEED_WEB.getWebEventJsonRange(key,offset,limit)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end

  #获取feed 声音流的数据
  def self.get_track_by_timeline(key,timeLine,page_size,type)
    begin
      Yajl::Parser.parse FEED_WEB.getWebTrackJsonTimeline(key,timeLine,page_size,type)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end

  #获取feed event的数据
  def self.get_track_by_range(key,offset,limit)
    begin
      Yajl::Parser.parse FEED_WEB.getWebTrackJsonRange(key,offset,limit)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end
  #删除feed
  # @param uid 用户id
  # @param feedId feed的id
  # @param groupIds 分组id
  # @param type feed的类型 event|sound
  def self.deleteFeed(uid,feedId,groupIds,type)
    begin
      FEED_WEB.deleteFeed(uid,feedId,type,groupIds)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end

  #获得用户未读数量
  # @param key 用户id或者用户id+分组id
  def self.no_read_num2 key
    begin
      FEED_WEB.getWebUnreadNumJson(key)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end


  #现在未使用 获得feed的播放列表
  def self.get_play_list uid,page_size
    begin
      FEED_WEB.getContentList(uid,page_size)
    rescue Exception => e
      logger.error e.message
      nil
    end
  end
#去除内容，仅保留分页信息的feed
  def self.get_feed_data feed,timeLine
    feedData = feed["feedData"]
    if feedData && feedData.length !=0
       timeLine = feedData[feedData.length-1]['timeLine']
       feed.store("timeLine",timeLine)
    end
    feed.delete "feedData"
	  if feed['timeLine'].nil?
      feed['timeLine']=timeLine
    end

    feed.to_json
  end
  #组装所有的用户信息
  def self.get_feed_uids feed
    feedData = feed["feedData"]
    uids = Array.new
    if feedData && feedData.length !=0
       feedData.each do |f|
		 #判断转发
		 if f['type'] && f['type']=='fts'
			uids.push(f['toUid'])
		 end
         uids.push(f['uid'])
       end
    end
    uids.uniq
  end
end
