require File.expand_path('../following_node', __FILE__)
require File.expand_path('../following_origin', __FILE__)

class Following < FollowingOrigin
  
  def self.shard(key)
    Object.const_get(FollowingNode.seek(key).class_name)
  end

  def self.gtn(key)
    FollowingNode.seek(key).table_name
  end
  
  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = Following.gtn(r.uid)
    unless r.id
      r.id = Following.next_id
    end
  end

  after_save do |r|
    hash = r.attributes
    hash.delete_if{|k,v| %w(id created_at updated_at).include? k }

    follower = Follower.shard(r.following_uid).where(uid: r.uid, following_uid: r.following_uid).first

    unless follower
      # 创建
      follower = Follower.shard(r.following_uid).new
    end
    follower.id = r.id
    follower.update_attributes(hash)
  end

  before_destroy do |r|
    r.class.table_name = Following.gtn(r.uid)
  end

  after_destroy do |r|
    # 关注数 - 1
    Following.decr_user_followings_count(r.uid)

    follower = Follower.shard(r.following_uid).where(uid: r.uid, following_uid: r.following_uid).first

    if follower
      follower.destroy 
      # 粉丝数 - 1
      Following.decr_user_followers_count(follower.following_uid)
    end
  end

end
