require File.expand_path('../../extenders/following_group_extender', __FILE__)

class FollowingGroupOrigin < ActiveRecord::Base
  extend FollowingGroupExtender

  # 关注分组
  self.table_name = 'tb_following_group'

  attr_accessible :uid,
                  :is_public,
                  :title,
                  :is_auto_download, 
                  :order_num

  # uid --- 用户id
  # is_public --- 是否公开
  # title --- 分组名，一个用户不能有重名的组
  # is_auto_download --- 是否自动离线下载，一个用户只能有一个自动离线下载的组
  # order_num --- 排序号

  validates :uid, presence: true

  before_save do |r|
    unless r.id
      r.id = FollowingGroup.next_id
    end
  end

end
