require File.expand_path('../following_tag_node', __FILE__)
require File.expand_path('../following_tag_origin', __FILE__)

class FollowingTag < FollowingTagOrigin
  
  def self.shard(key)
    Object.const_get(FollowingTagNode.seek(key).class_name)
  end

  def self.gtn(key)
    FollowingTagNode.seek(key).table_name
  end

  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = FollowingTag.gtn(r.uid)
    
    unless r.id
      r.id = FollowingTag.next_id
    end
  end

  after_save do |r|
    hash = r.attributes
    hash.delete_if{|k,v| %w(id created_at updated_at).include? k }

    follower_tag = FollowerTag.shard(r.tname).where(id: r.id).first
    unless follower_tag
      # 创建
      follower_tag = FollowerTag.shard(r.tname).new
      follower_tag.id = r.id
      follower_tag.created_at = r.created_at
      follower_tag.updated_at = r.updated_at
    end
    follower_tag.update_attributes(hash)
  end

  before_destroy do |r|
    r.class.table_name = FollowingTag.gtn(r.uid)
  end

  after_destroy do |r|
    # 删副本
    follower_tag = FollowerTag.shard(r.tname).where(id: r.id).first
    follower_tag.destroy if follower_tag
  end

end
