class LoverAlbumOrigin < ActiveRecord::Base

  # 收藏专辑 根据album_id分表
  self.table_name = 'tb_favorite_album'

  attr_accessible :uid,
          :nickname,
          :avatar_path,
          :album_id,
          :album_uid,
          :album_nickname,
          :album_avatar_path,
          :op_type,
          :user_source,
          :is_crawler,
          :title,
          :tags,
          :intro,
          :cover_path,
          :music_category, 
          :album_created_at,
          :category_id,
          :created_at,
          :updated_at,
          :upload_source 

  # uid nickname avatar_path --- 用户id 昵称 头像
  # album_id album_uid album_nickname album_avatar_path --- 专辑id 用户id 昵称 头像
  # op_type --- 专辑上传类型 1:自己传的 /2:转发
  # user_source --- 专辑来源 1:原创 /2:采集
  # is_crawler --- 专辑 是否爬虫
  # title tags intro cover_path --- 专辑标题 标签 简介 封面
  # music_category --- 专辑 音乐归类
  # album_created_at --- 专辑创建时间
  # category_id --- 专辑分类id
  # upload_source --- 专辑上传自 1:iphone/2:电脑/3:android

  validates :album_id, presence: true
end
