class LoverOrigin < ActiveRecord::Base
  # 喜欢声音 根据track_id分表，记录依赖favorite
  self.table_name = 'tb_favorite' 

  attr_accessible :is_public, :upload_source,
                  :uid, :nickname, :avatar_path,
                  :track_id, :track_uid, :track_upload_source, :track_nickname, :track_avatar_path, :track_duration,
                  :user_source, :category_id,
                  :title, :intro,
                  :duration,
                  :download_path,
                  :play_path, :play_path_32, :play_path_64, :play_path_128,
                  :cover_path, 
                  :cover_path_small, :cover_path_middle, :cover_path_large, :cover_path_wide,
                  :cover_path_60, :cover_path_86, :cover_path_640,  
                  :tags,  
                  :allow_download, :allow_comment,
                  :track_created_at, :track_updated_at,
                  :album_id, :album_title, :album_cover_path, :is_v, 
                  :waveform, :upload_id
  
  # is_public --- 是否公开
  # upload_source --- 操作自 1:iphone /2:电脑 /3:android
  # uid nickname avatar_path --- 用户id 昵称 头像地址
  # track_id track_uid track_nickname track_avatar_path --- 声音id uid 昵称 发布者头像
  # track_upload_source --- 声音上传自 1:iphone /2:电脑 /3:android
  # track_duration --- 声音时长
  # user_source --- 声音来源 1:原创/2:采集
  # category_id --- 声音分类id
  # title intro --- 声音标题 简介
  # duration --- 声音时长
  # download_path --- 声音下载地址
  # play_path play_path_32 play_path_64 play_path_128 --- 播放地址原 32Kbps 64Kbps 128Kbps
  # cover_path --- 声音封面路径原
  # cover_path_small cover_path_middle cover_path_large cover_path_wide --- 未使用 50x50 100x100 180x180 400x300 
  # cover_path_60 cover_path_86 cover_path_640 --- 60x60 86x86 640x640
  # tags --- 声音标签
  # allow_download allow_comment --- 允许下载 允许评论
  # track_created_at track_updated_at --- 声音创建时间 更新时间
  # album_id album_title album_cover_path --- 专辑id 标题 封面
  # is_v --- 声音作者是否加V
  # waveform upload_id --- 声音波形 上传号

  validates :track_id, presence: true
end
