require File.expand_path('../outbox_node', __FILE__)
require File.expand_path('../outbox_origin', __FILE__)

class Outbox < OutboxOrigin

  def self.shard(key)
    Object.const_get(OutboxNode.seek(key).class_name)
  end

  def self.gtn(key)
    OutboxNode.seek(key).table_name
  end
  
  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = Outbox.gtn(r.uid)

    unless r.id
      r.id = Outbox.next_id
    end
  end

  before_destroy do |r|
    r.class.table_name = Outbox.gtn(r.uid)
  end

end
