require File.expand_path('../../extenders/outbox_extender', __FILE__)

class OutboxOrigin < ActiveRecord::Base
  extend OutboxExtender
  
  # 消息 根据uid分表
  self.table_name = 'tb_message' 

  attr_accessible :message_type,
                  :upload_source,
                  :uid, :nickname, :avatar_path,  
                  :to_uid, :to_nickname, :to_avatar_path,
                  :content, 
                  :extra_json, 
                  :has_read,
                  :track_id, :track_title, :track_cover_path, :track_uid, :track_nickname, :track_upload_source,
                  :comment_id, :second, :pcomment_id, :pcomment_content,
                  :anno_id, :anno_created_at


  # message_type --- 
  # 1: 私信（已废弃）
  # 2: 你评论了 发件箱
  # 3: 你的评论被回复了 收件箱
  # 4: 你的评论被@了 收件箱
  # 5: 有一个公告(喜马发的) 收件箱
  # 6: 有一封系统私信(加v通过等，喜马发的) 收件箱
  # 7: 你的声音被喜欢了 收件箱
  # 8: 你的声音被转发了 收件箱
  # 9: 主动推 默认类型
  # 10: 主动推 系统通知
  # 11: 主动推 声音详情页
  # 12: 主动推 个人主页
  # 13: 主动推 专辑详情页
  # 14: 你的声音被@到了 收件箱
  # 15: 主动推 自定义url
  # 16: 主播发来了私信 收件箱

  # upload_source --- 发自 1:iphone/2:电脑/3:android
  # uid nickname avatar_path --- 用户id 昵称 头像
  # to_uid to_nickname to_avatar_path --- 发给用户id 昵称 头像
  # content --- 内容 
  # extra_json --- 额外json 
  # has_read --- 是否已读
  # track_id track_title track_cover_path --- 声音id 标题 封面
  # track_uid track_nickname track_upload_source --- 声音用户id 昵称 上传自
  # comment_id second --- 评论id 第几秒
  # pcomment_id pcomment_content --- 父评论id 内容
  # anno_id anno_created_at --- 公告id 创建时间

  validates :uid, presence: true

  before_save do |r|
    unless r.id
      r.id = Outbox.next_id
    end
  end

end
