class PersonalSetting < ActiveRecord::Base
  self.table_name = 'tb_personal_setting' # 个人设置

  attr_accessible :uid, :notice_comment, :notice_download, :notice_fan,
                  :notice_favorite, :notice_message, :notice_share,
                  :notice_upload, :allow_comment, :allow_message, :allow_at_me_content,
                  :banned_to_post, :expire_banned_to_post_at, :notice_quan,
                  :no_push_start_hour, :no_push_start_minute, :no_push_end_hour, :no_push_end_minute,
                  :is_push_new_follower, :is_push_new_comment, :is_push_new_message, :is_push_new_quan,
                  :is_push_new_favorite, :offline_download_group_id, :is_feed_following, :is_feed_favorite, :is_feed_comment

  
  
  # uid --- 用户id
  # notice_comment notice_download notice_fan notice_favorite notice_message notice_share notice_upload notice_quan --- 是否收xxx通知
  # allow_comment allow_message allow_at_me_content --- 被xxx操作设置
  # banned_to_post expire_banned_to_post_at --- 被禁止发布内容 过期时间
  # no_push_start_hour no_push_start_minute no_push_end_hour no_push_end_minute --- 不受推送起止时间
  # is_push_new_follower is_push_new_comment is_push_new_message is_push_new_quan is_push_new_favorite --- 是否被推送xxx
  # offline_download_group_id --- 离线下载组id
  # is_feed_following is_feed_favorite is_feed_comment --- 是否发给粉丝feed：我的关注、喜欢、评论

  # allow_xxx --- 1:所有人/2:我关注的人、认证主播、关注我的人/3:仅我关注的人/4:全部不允许

  belongs_to :profile, foreign_key: "uid"
end
