class ReportInformation < ActiveRecord::Base
  self.table_name = 'tb_report_information' # 举报详情
  attr_accessible  :uid, :nickname, :is_processed, :report_id, :to_nickname, :to_uid, :content_id, :content_title,
                   :content_type, :fujian_path, :content, :cover_path, :track_id, :album_id, :comment_id
  
  # uid nickname --- 用户id 昵称
  # report_id content_type is_processed --- 举报id 举报类型 是否被处理
  # content_id --- 未使用
  # track_id album_id comment_id content_title cover_path --- 举报声音/专辑/评论id 内容标题 内容图片
  # to_uid to_nickname --- 举报谁id 昵称
  # content fujian_path 内容 附件

  # content_type设置
  TYPE = {"track"=>1,"album"=>1,"comment"=>2}

  belongs_to :report

  def is_processed_disp
    case self.is_processed
      when true
        "已处理"
      when false
        "未处理"
      else
        ""
    end
  end

end
