require File.expand_path('../track_block_node', __FILE__)
require File.expand_path('../track_block_origin', __FILE__)

class TrackBlock < TrackBlockOrigin
  
  def self.shard(key)
    Object.const_get(TrackBlockNode.seek(key).class_name)
  end

  def self.gtn(key)
    TrackBlockNode.seek(key).table_name
  end
  
  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = TrackBlock.gtn(r.track_id)

    unless r.id
      r.id = TrackBlock.next_id
    end

    # 如果播放时长被赋值，没有块记录，设置块
    if r.duration and r.blocks.nil?
      b = (r.duration / MIN_SECONDS_PER_BLOCK + 1).to_i # 块数
      b = TRACK_MAX_BLOCKS if b > TRACK_MAX_BLOCKS

      sec_per_block = r.duration / b # 每秒长度
      flags = []
      b.times do |i|
        flags << "%5.3f" % (sec_per_block * i)
      end
      
      r.blocks = b
      r.flags = flags.join(',')
    end
  end

  before_destroy do |r|
    r.class.table_name = TrackBlock.gtn(r.track_id)
  end

end
