require File.expand_path('../../extenders/track_in_record_extender', __FILE__)

class TrackInRecordOrigin < ActiveRecord::Base
  extend TrackInRecordExtender
  # 声音记录 根据track_id分表

  self.table_name = 'tb_track_record' 

  attr_accessible :track_id,
                  :track_uid,
                  :track_upload_source,
                  :op_type,
                  :is_publish,
                  :upload_source, 
                  :uid, :nickname, :avatar_path, :is_v, :human_category_id,
                  :title, :intro, 
                  :user_source, 
                  :category_id, 
                  :duration, 
                  :play_path, :play_path_32, :play_path_64, :play_path_128,  
                  :transcode_state,
                  :download_path, 
                  :cover_path, 
                  :album_id, :album_title, 
                  :album_cover_path,
                  :tags, :ignore_tags, :extra_tags,
                  :singer, :singer_category, :author, 
                  :composer, :arrangement, :post_production, 
                  :lyric, :lyric_path, 
                  :language, :resinger, :announcer, 
                  :is_public, :access_password, 
                  :allow_download, :allow_comment, 
                  :is_crawler, :inet_aton_ip,  :longitude, :latitude,
                  :music_category, :order_num, :is_pick,
                  :rich_intro, :short_intro, :comment_content, :comment_id,
                  :dig_status, :approved_at,
                  :is_deleted,
                  :mp3size, :mp3size_32, :mp3size_64, :waveform,
                  :created_at, :updated_at, :upload_id, :id,
                  :source_url, :status, :explore_height, :download_size


  # op_type --- 1:自己传的 /2:转发（根据原track产生又一条record记录）
  # track_id track_upload_source --- 声音id 上传源
  # track_uid --- 声音用户id
  # comment_content --- 转发时输入的评论

  validates :track_id, presence: true

  OP_TYPE = { UPLOAD: 1, RELAY: 2 }

  after_save do |r|
    TrackInRecord.del_cache(r)
  end

  after_destroy do |r|
    TrackInRecord.del_cache(r)
  end

  def self.hashlize(obj)
    {
      id: obj.id, 
      track_id: obj.track_id, 
      uid: obj.uid, 
      op_type: obj.op_type, 
      nickname: obj.nickname, 
      avatar_path: obj.avatar_path, 
      is_v: obj.is_v, 
      is_public: obj.is_public, 
      is_publish: obj.is_publish, 
      user_source: obj.user_source, 
      category_id: obj.category_id, 
      title: obj.title, 
      intro: obj.intro, 
      tags: obj.tags, 
      cover_path: obj.cover_path, 
      duration: obj.duration, 
      download_path: obj.download_path, 
      play_path: obj.play_path, 
      play_path_128: obj.play_path_128, 
      play_path_64: obj.play_path_64, 
      play_path_32: obj.play_path_32, 
      singer: obj.singer, 
      singer_category: obj.singer_category, 
      author: obj.author, 
      composer: obj.composer, 
      arrangement: obj.arrangement, 
      post_production: obj.post_production, 
      lyric: obj.lyric, 
      lyric_path: obj.lyric_path, 
      language: obj.language, 
      resinger: obj.resinger, 
      announcer: obj.announcer, 
      access_password: obj.access_password, 
      allow_download: obj.allow_download, 
      allow_comment: obj.allow_comment, 
      is_crawler: obj.is_crawler, 
      inet_aton_ip: obj.inet_aton_ip, 
      upload_source: obj.upload_source, 
      longitude: obj.longitude, 
      latitude: obj.latitude, 
      album_id: obj.album_id, 
      album_title: obj.album_title, 
      album_cover_path: obj.album_cover_path, 
      transcode_state: obj.transcode_state, 
      created_at: obj.created_at, 
      updated_at: obj.updated_at, 
      rich_intro: obj.rich_intro, 
      comment_content: obj.comment_content, 
      comment_id: obj.comment_id, 
      track_upload_source: obj.track_upload_source, 
      is_pick: obj.is_pick, 
      track_uid: obj.track_uid, 
      short_intro: obj.short_intro, 
      is_deleted: obj.is_deleted, 
      dig_status: obj.dig_status, 
      approved_at: obj.approved_at, 
      mp3size: obj.mp3size, 
      mp3size_32: obj.mp3size_32, 
      mp3size_64: obj.mp3size_64, 
      upload_id: obj.upload_id, 
      waveform: obj.waveform, 
      extra_tags: obj.extra_tags, 
      ignore_tags: obj.ignore_tags, 
      music_category: obj.music_category, 
      order_num: obj.order_num, 
      source_url: obj.source_url, 
      status: obj.status, 
      human_category_id: obj.human_category_id, 
      explore_height: obj.explore_height
    }
  end

end
