require File.expand_path('../track_record_node', __FILE__)
require File.expand_path('../track_record_origin', __FILE__)

class TrackRecord < TrackRecordOrigin

  def self.shard(key)
    Object.const_get(TrackRecordNode.seek(key).class_name)
  end

  def self.gtn(key)
    TrackRecordNode.seek(key).table_name
  end

  def self.stn(key)
    self.table_name = self.gtn(key)
    self
  end

  before_save do |r|
    r.class.table_name = TrackRecord.gtn(r.uid)

    unless r.id
      r.id = TrackRecord.next_id
    end
  end

  before_destroy do |r|
    r.class.table_name = TrackRecord.gtn(r.uid)
  end

end
