require File.expand_path('../../extenders/track_record_extender', __FILE__)
require File.expand_path('../track_in_record', __FILE__)

class TrackRecordOrigin < ActiveRecord::Base
  extend TrackRecordExtender
  # 声音记录 根据uid分表

  self.table_name = 'tb_track_record' 

  attr_accessible :track_id,
                  :track_uid,
                  :track_upload_source,
                  :op_type,
                  :is_publish,
                  :upload_source, 
                  :uid, :nickname, :avatar_path, :is_v, :human_category_id,
                  :title, :intro, 
                  :user_source, 
                  :category_id, 
                  :duration, 
                  :play_path, :play_path_32, :play_path_64, :play_path_128,  
                  :transcode_state,
                  :download_path, 
                  :cover_path, 
                  :album_id, :album_title, 
                  :album_cover_path,
                  :tags, :ignore_tags, :extra_tags,
                  :singer, :singer_category, :author, 
                  :composer, :arrangement, :post_production, 
                  :lyric, :lyric_path, 
                  :language, :resinger, :announcer, 
                  :is_public, :access_password, 
                  :allow_download, :allow_comment, 
                  :is_crawler, :inet_aton_ip,  :longitude, :latitude,
                  :music_category, :order_num, :is_pick,
                  :rich_intro, :short_intro, :comment_content, :comment_id,
                  :dig_status, :approved_at,
                  :is_deleted,
                  :mp3size, :mp3size_32, :mp3size_64, :waveform,
                  :created_at, :updated_at, :upload_id, :id,
                  :source_url, :status, :explore_height, :download_size


  # op_type --- 1:自己传的 /2:转发（根据原track产生又一条record记录）
  # track_id track_upload_source --- 声音id 上传源
  # track_uid --- 声音用户id
  # comment_content --- 转发时输入的评论

  validates :uid, presence: true

  OP_TYPE = { UPLOAD: 1, RELAY: 2 }

  before_save do |r|
    unless r.id
      r.id = TrackRecord.next_id
    end
  end

  after_destroy do |r|
    tir = TrackInRecord.shard(r.track_id).where(id: r.id).first
    tir.destroy if tir
  end

end
