require File.expand_path('../../extenders/track_rich_extender', __FILE__)

class TrackRichOrigin < ActiveRecord::Base
  extend TrackRichExtender

  # 声音富文本 分表 根据 track_id
  self.table_name = 'tb_track_rich'

  attr_accessible :track_id, 
                  :rich_intro,
                  :mid_intro,
                  :lyric
  
  # track_id --- 声音id
  # rich_intro --- 带格式完整介绍
  # mid_intro --- 未使用
  # lyric --- 歌词

  validates :track_id, presence: true

  before_save do |r|
    unless r.id
      r.id = TrackRich.next_id
    end
  end

  after_save do |r|
    RICKREDIS.del("t_e_#{r.track_id}_2")
  end

end
