class VApplication < ActiveRecord::Base
  self.table_name = 'tb_v_application' # 加v申请

  attr_accessible :uid, :real_name, :identity_card, :gender, :age_range, :phone, :address, :qqmsn, :businesscard_path, :track_id, 
                  :track_category, :tags, :intro, :status, :audited_at, :auditer_id, :auditer_name, :ptitle, :company, :human_category_id,
                  :email
  
  # status --- 0:待提交 /1:待审核 /2:审核通过 /3:审核失败
  # uid --- 用户id
  # real_name gender age_range --- 姓名 性别 年龄段
  # identity_card --- 身份证
  # phone address qqmsn email --- 电话 地址 qq号 邮件地址
  # businesscard_path --- 附件
  # track_id --- 声音id
  # track_category tags intro --- 声音分类 标签 介绍
  # audited_at auditer_id auditer_name --- 审核时间 审核id 审核人
  # ptitle company --- 主播抬头 公司
  # human_category_id --- 人分类id

  belongs_to :profile, :foreign_key => "uid"
  belongs_to :human_category, :foreign_key => "human_category_id"

  def status_disp
    case self.status
      when 0
        "待提交"
      when 1
        "待审核"
      when 2
        "审核通过"
      when 3
        "审核不通过"
    end
  end
end
